package  
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Draw;
	/**
	 * ...
	 * @author Time
	 */
	public class Particle extends Entity
	{
		public var radius:Number;
		private var mass:Number = Math.random() * 75+25;
		private var dampen:Number = 0.95;
		public var v:Point = new Point();
		
		public function Particle(_x:int, _y:int) 
		{
			super(_x, _y);
			type = "Circle";
			radius = Math.sqrt(mass) / 2;
			setHitbox(radius * 2, radius * 2, radius, radius);
		}
		
		override public function update():void
		{
			while (x < 0)
			{
				x += FP.width;
			}
			while (x > FP.width)
			{
				x -= FP.width;
			}
			while (y < 0)
			{
				y += FP.height;
			}
			while (y > FP.height)
			{
				y -= FP.height;
			}
			
			var myX:int = Game.getX(x);
			var myY:int = Game.getY(y);
			
			v.x += Game.vectors[myX][myY].x / mass;
			v.y += Game.vectors[myX][myY].y / mass;
			
			v.x *= dampen;
			v.y *= dampen;
			
			x += v.x;
			y += v.y;
			
			var c:Particle = collide("Circle", x, y) as Particle;
			if (c)
			{
				var d:Number = FP.distance(x, y, c.x, c.y);
				if (d <= c.radius + radius)
				{
					var n:Point = new Point(x - c.x, y - c.y);
					n.normalize(1);
					var p:Number = 2 * (v.x * n.x + v.y * n.y - c.v.x * n.x - c.v.y * n.y) / (mass + c.mass);
					v.x -= p * c.mass * n.x;
					v.y -= p * c.mass * n.y;
					c.v.x += p * mass * n.x;
					c.v.y += p * mass * n.y;
					
					var deltaD:Number = c.radius + radius - d;
					const tMass:Number = mass + c.mass;
					x += n.x * deltaD * c.mass / tMass;
					y += n.y * deltaD * c.mass / tMass;
					c.x -= n.x * deltaD * mass / tMass;
					c.y -= n.y * deltaD * mass / tMass;
				}
			}
		}
		
		override public function render():void
		{
			var col:uint = FP.colorLerp(0x0000FF, 0xFFFFFF, v.length / 5);
			Draw.circle(x, y, radius, col);
		}
	}
}